<?php
/**
 *	Flare_AppSQL.php
 *
 *	@author		Masaki Fujimoto <fujimoto@php.net>
 *	@package	Flare
 *	@version	$Id: Flare_AppSQL.php,v 1.16 2005/05/09 14:29:39 masaki-f Exp $
 */


/**
 *	FlareץꥱSQL饹
 *
 *	@author		Masaki Fujimoto <fujimoto@php.net>
 *	@access		public
 *	@package	Flare
 */
class Flare_AppSQL extends Ethna_AppSQL
{
    function get_tag_list()
    {
        return "SELECT tag.id, tag.name, COUNT(*) AS rate FROM tag, journal_tag WHERE tag.id=journal_tag.tag_id GROUP BY name;";
    }

    function get_user_tag_list($user_id)
    {
        return "SELECT tag.id, tag.name, COUNT(*) as rate FROM tag, journal_tag, journal WHERE journal.user_id=$user_id AND journal_tag.journal_id=journal.id AND tag.id = journal_tag.tag_id GROUP BY tag.name;";
    }

    function get_journal_list($user_id, $account_id, $date_from, $date_to, $tag_list, $sort_key, $sort_order, $offset, $count)
    {
        $condition = "";
        if ($user_id != "''") {
            $condition .= " AND journal.user_id=$user_id";
        }
        if ($account_id != "''") {
            $condition .= " AND journal.account_id=$account_id";
        }
        if ($date_from != "''") {
            $condition .= " AND journal.ctime>=$date_from";
        }
        if ($date_to != "''") {
            $condition .= " AND journal.ctime<=$date_to";
        }
        if (is_array($tag_list)) {
            $condition .= " AND tag.name IN (" . implode(',', $tag_list) . ")";
        } else if ($tag_list != "''") {
            $condition .= " AND tag.name=$tag_list"; 
        }

        if ($sort_key != "''") {
            Ethna_AppSQL::unescapeSQL($sort_key);
            $order = " ORDER BY $sort_key";

            Ethna_AppSQL::unescapeSQL($sort_order);
            if ($sort_order) {
                $order .= " DESC";
            }
        }

        $limit = "";
        if ($offset != "''") {
            Ethna_AppSQL::unescapeSQL($offset);
            $limit = " LIMIT $offset,";
        }
        if ($count == "''") {
            $count = "-1";
        } else {
            Ethna_AppSQL::unescapeSQL($count);
        }
        if ($limit) {
            $limit .= $count;
        } else {
            $limit .= "LIMIT $count";
        }

        $query = "SELECT user.user_id, user.name as user_name, user.alias, " .
            "account.id as account_id, account.name as account_name, " .
            "journal.id as journal_id, journal.inout, journal.name AS journal_name, " .
            "journal.ctime, tag.name AS tag_name FROM user, account, journal, journal_tag, tag " .
            "WHERE user.user_id=journal.user_id AND account.id=journal.account_id AND journal.id=journal_tag.journal_id " .
            "AND journal_tag.tag_id=tag.id$condition$order$limit";
        return $query;
    }
    
    function get_journal_id_list($user_id, $account_id, $date_from, $date_to, $tag_list)
    {
        $condition = "";
        if ($user_id != "''") {
            $condition .= " AND journal.user_id=$user_id";
        }
        if ($account_id != "''") {
            $condition .= " AND journal.account_id=$account_id";
        }
        if ($date_from != "''") {
            $condition .= " AND journal.ctime>=$date_from";
        }
        if ($date_to != "''") {
            $condition .= " AND journal.ctime<=$date_to";
        }
        if (is_array($tag_list)) {
            $condition .= " AND tag.name IN (" . implode(',', $tag_list) . ")";
        } else if ($tag_list != "''") {
            $condition .= " AND tag.name=$tag_list"; 
        }

        $query = "SELECT journal.id AS journal_id FROM user, account, journal, journal_tag, tag " .
            "WHERE user.user_id=journal.user_id AND account.id=journal.account_id AND journal.id=journal_tag.journal_id " .
            "AND journal_tag.tag_id=tag.id$condition GROUP BY journal.id";
        return $query;
    }

    function get_journal_sum($journal_id_list)
    {
        $condition = "";
        if (is_array($journal_id_list)) {
            $condition .= " AND journal.id IN (" . implode(',', $journal_id_list) . ")";
        } else if ($journal_id_list != "''") {
            $condition .= " AND journal.id=$journal_id_list"; 
        }

        $query = "SELECT SUM(journal.inout) AS inout_sum FROM journal WHERE 1 $condition";
        return $query;
    }

    function get_hash($user_hash, $account_hash)
    {
        Ethna_AppSQL::unescapeSQL($user_hash);
        Ethna_AppSQL::unescapeSQL($account_hash);

        $query = "SELECT user.user_id, account.id AS account_id FROM user, account " .
            "WHERE user.user_id=account.user_id AND user.hash LIKE '$user_hash%' AND " .
            "account.hash LIKE '$account_hash%';";
        return $query;
    }
}
