<?php
/**
 *	Flare_Journal.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.app_object.php,v 1.2 2006/03/07 16:23:18 fujimoto Exp $
 */

/**
 *	Flare_JournalManager
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_JournalManager extends Ethna_AppManager
{
    function getJournalList($user_id, $account_id, $date_from, $date_to, $tag_list, $sort_key, $sort_order, $offset, $count)
    {
        $r = $this->db->sqlquery('get_journal_list', $user_id, $account_id, $date_from, $date_to, $tag_list, $sort_key, $sort_order, $offset, $count);
        if (Ethna::isError($r)) {
            return $r;
        }

        $journal_list = array();
        while ($row = $r->fetchRow(DB_FETCHMODE_ASSOC)) {
            $journal_id = $row['journal_id'];
            if (empty($journal_list[$journal_id])) {
                $row['tag_name'] = to_array($row['tag_name']);
                $journal_list[$journal_id] = $row;
            } else {
                $journal_list[$journal_id]['tag_name'][] = $row['tag_name'];
            }
        }

        $r = $this->db->sqlquery('get_journal_id_list', $user_id, $account_id, $date_from, $date_to, $tag_list);
        if (Ethna::isError($r)) {
            return $r;
        }
        $journal_id_list = array();
        while ($row = $r->fetchRow(DB_FETCHMODE_ASSOC)) {
            $journal_id_list[] = $row['journal_id'];
        }
        if (count($journal_id_list) == 0) {
            return array(0, $journal_id_list);
        }

        $r = $this->db->sqlquery('get_journal_sum', $journal_id_list);
        $row = $r->fetchRow(DB_FETCHMODE_ASSOC);

        return array($row['inout_sum'], $journal_list);
    }
}

/**
 *	Flare_Journal
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Journal extends Ethna_AppObject
{
    /**
     *  ץѥƥɽ̾
     *
     *  @access public
     */
    function getName($key)
    {
        return $this->get($key);
    }
}
?>
